#include <allegro.h>
#include "ColorPicker.h"

int color_dealey_proc( int msg, DIALOG *d, int c );

DIALOG CP_dlg[]=
{
     /* proc,                    x,   y,   w,   h,   fg,  bg,  key, flags,  d1,         d2, dp,              dp2,      dp3 */
/*00*/{ d_shadow_box_proc,       0,   0,   145, 155, 0,   0,   0,   0,      0,          0,  NULL,            NULL,     NULL },
/*01*/{ color_dealey_proc,       4,   4,   135, 145, 0,   0,   0,   0,      0,          0,  NULL,            NULL,     NULL },
/*02*/{ d_button_proc,           54,  133, 38,  15,  0,   0,   0,   D_EXIT, 0,          0,  "Keep",          NULL,     NULL },
/*03*/{ d_button_proc,           100, 133, 38,  15,  0,   0,   0,   D_EXIT, 0,          0,  "Toss",          NULL,     NULL },
      { NULL,                    0,   0,   0,   0,   0,   0,   0,   0,      0,          0,  NULL,            NULL,     NULL }
};

void __draw_h_and_s_cur( int color, int sx, int sy )
{
    float rh, rs, rv;

    rgb_to_hsv( getr(color), getg(color), getb(color), &rh, &rs, &rv );
    drawing_mode( DRAW_MODE_XOR, NULL, 0, 0 );
    circle( screen, sx+(int)(rh/360.*120), sy+(int)(rs*125), 4, 0xffffffff );
    drawing_mode( DRAW_MODE_SOLID, NULL, 0, 0 );
}

void __draw_h_and_s_box( int color, int sx, int sy )
{
    float h, s;//, v;
    float rh, rs, rv;
    int x, y, r, g, b;

    rgb_to_hsv( getr(color), getg(color), getb(color), &rh, &rs, &rv );
    x = y = 0;
    for( h = 0.; h < 360.; h+=3. ){
       for( s = 0.; s < 1.; s+=0.008 ){
          hsv_to_rgb( h, s, rv, &r, &g, &b );
          putpixel( screen, sx+x, sy+y, makecol( r, g, b ) );
          y++;
          }
       x++;
       y = 0;
       }
}

void __draw_v_cur( int color, int sx, int sy )
{
    float rh, rs, rv;

    rgb_to_hsv( getr(color), getg(color), getb(color), &rh, &rs, &rv );
    drawing_mode( DRAW_MODE_XOR, NULL, 0, 0 );
    hline( screen, sx+124, sy+(int)(rv*125), sx+133, 0xffffffff );
    drawing_mode( DRAW_MODE_SOLID, NULL, 0, 0 );
}

void __draw_v_box( int color, int sx, int sy )
{
    float /*h, s,*/ v;
    float rh, rs, rv;
    int x, y, r, g, b;

    rgb_to_hsv( getr(color), getg(color), getb(color), &rh, &rs, &rv );
    y = 0;
    for( v = 0.; v < 1.; v+=0.008 ){
       for( x = 0; x < 10; x++ ){
          hsv_to_rgb( rh, rs, v, &r, &g, &b );
          putpixel( screen, sx+x+124, sy+y, makecol( r, g, b ) );
          }
       y++;
       }
}

void __draw_samp_box( int color, int sx, int sy )
{
    rectfill( screen, sx, sy+129, sx+44, sy+143, color );
}

void __draw_color_boxes( int color, int sx, int sy )
{
    __draw_h_and_s_box( color, sx, sy );
    __draw_h_and_s_cur( color, sx, sy );
    __draw_v_box( color, sx, sy );
    __draw_v_cur( color, sx, sy );
    __draw_samp_box( color, sx, sy );
}

int color_dealey_proc( int msg, DIALOG *d, int c )
{
    float rh, rs, rv;
    int r, g, b, omx=-1, omy=-1;
    c = 0;

    switch( msg ){
      case MSG_DRAW:
           scare_mouse();
           __draw_color_boxes( d->d1, d->x, d->y );
           unscare_mouse();
           break;

      case MSG_CLICK:
           rgb_to_hsv( getr(d->d1), getg(d->d1), getb(d->d1), &rh, &rs, &rv );
           if( mouse_x >= d->x     && mouse_y >= d->y &&
               mouse_x <= d->x+120 && mouse_y <= d->y+125 ){
             scare_mouse();
             while( mouse_x >= d->x     && mouse_y >= d->y &&
                    mouse_x <= d->x+120 && mouse_y <= d->y+125 &&
                    mouse_b ){
               if( mouse_x != omx || mouse_y != omy ){
                 hsv_to_rgb( (mouse_x-d->x)*3.0, (mouse_y-d->y)*0.008, rv, &r, &g, &b );
                 __draw_h_and_s_cur( d->d1, d->x, d->y );
                 d->d1 = makecol( r, g, b );
                 __draw_h_and_s_cur( d->d1, d->x, d->y );
                 __draw_v_box( d->d1, d->x, d->y );
                 __draw_v_cur( d->d1, d->x, d->y );
                 __draw_samp_box( d->d1, d->x, d->y );
                 omx = mouse_x;
                 omy = mouse_y;
                 }
               }
             unscare_mouse();
             }
           else if( mouse_x >= d->x+125 && mouse_y >= d->y &&
                    mouse_x <= d->x+134 && mouse_y <= d->y+125 ){
             scare_mouse();
             while( mouse_x >= d->x+125 && mouse_y >= d->y &&
                    mouse_x <= d->x+134 && mouse_y <= d->y+125 &&
                    mouse_b ){
               if( mouse_x != omx || mouse_y != omy ){
                 hsv_to_rgb( rh, rs, (mouse_y-d->y)*0.008, &r, &g, &b );
                 __draw_v_cur( d->d1, d->x, d->y );
                 d->d1 = makecol( r, g, b );
                 __draw_v_cur( d->d1, d->x, d->y );
                 __draw_h_and_s_box( d->d1, d->x, d->y );
                 __draw_h_and_s_cur( d->d1, d->x, d->y );
                 __draw_samp_box( d->d1, d->x, d->y );
                 omx = mouse_x;
                 omy = mouse_y;
                 }
               }
             unscare_mouse();
             }
           break;
      }

    return D_O_K;
}

int ColorPicker( int color )
{
    set_dialog_color( CP_dlg, gui_fg_color, gui_bg_color );
    centre_dialog( CP_dlg );
    CP_dlg[1].d1 = color;
    if( do_dialog( CP_dlg, 1 ) == 2 )
      color = CP_dlg[1].d1;

    return color;
}